SystemOrganization addCategory: #'Glamour-Tests-Resources'!

Announcement subclass: #GLMItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Resources'!

Announcement subclass: #GLMItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Resources'!

Announcer subclass: #GLMAnnouncingCollection
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Resources'!

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
add: anObject

	collection add: anObject.
	self announce: GLMItemAdded! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
add: newObject before: oldObject 

	collection add: newObject before: oldObject.
	self announce: GLMItemAdded! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
add: newObject beforeOrLast: oldObject 
	(collection includes: oldObject)
		ifTrue: [ collection add: newObject before: oldObject ]
		ifFalse: [ collection add: newObject ].
	self announce: GLMItemAdded! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
at: anObject

	^collection at: anObject! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: ''!
collect: aBlock
	^collection collect: aBlock
	! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
do: aBlock

	^collection do: aBlock! !

!GLMAnnouncingCollection methodsFor: 'private' stamp: ''!
includes: anObject 
	^collection includes: anObject! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: 'AndreiChis 8/21/2013 15:17'!
indexOf: anElement

	^ collection indexOf: anElement! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	collection := OrderedCollection new! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
isCollection

	^true! !

!GLMAnnouncingCollection methodsFor: 'testing' stamp: ''!
isEmpty
	^ collection isEmpty! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
printString
	^ collection printString ! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
remove: anObject

	collection remove: anObject.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
remove: anObject ifAbsent: aBlock

	collection remove: anObject ifAbsent: aBlock.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
removeLast

	collection removeLast.
	self announce: GLMItemRemoved! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
size
	^ collection size! !

!GLMAnnouncingCollection methodsFor: 'initialization' stamp: ''!
withIndexDo: aBlock

	^collection withIndexDo: aBlock! !
